package extensions

import data._

/**
 * Implicit method extensions for map().
 */
package object map {

  implicit class LispListOps[+A](val list: LispList[A]) extends AnyVal {

    def map[B](f: A => B): LispList[B] = ???
  }

  implicit class SuperpositionOps[+A, +B](val fallible: Superposition[A, B]) extends AnyVal {

    def map[C](f: B => C): Superposition[A, C] = ???
  }

  implicit class SchrodingerOps[+A](val possibly: Schrodinger[A]) extends AnyVal {

    def map[B](f: A => B): Schrodinger[B] = ???
  }

  implicit class StateOps[S, +A](val state: State[S, A]) extends AnyVal {

    def map[B](f: A => B): State[S, B] = ???
  }
}
