package extensions

import org.scalatest.matchers.should.Matchers
import org.scalatest.wordspec.AnyWordSpecLike

class MapSpec extends AnyWordSpecLike with Matchers {
  "ConsList" can {
    "map" which {
      "transforms every element it contains" in {
        pending
      }
    }
  }

  "Superposition" can {
    "map" which {
      "ignores the value of Downside" in {
        pending
      }
      "transforms the value of Upside" in {
        pending
      }
    }
  }

  "Schrodinger" can {
    "map" which {
      "ignores Dead cat" in {
        pending
      }
      "transforms Alive cat" in {
        pending
      }
    }
  }

  "State" can {
    "map" which {
      "transforms the result of a stateful computation" in {
        pending
      }
    }
  }

  "Identity" can {
    "map" which {
      "transforms itself" in {
        pending
      }
    }
  }
}
